# kfp-tekton-server-api
This file contains REST API specification for Kubeflow Pipelines. The file is autogenerated from the swagger definition.

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.8.0rc7
- Package version: 1.8.0rc7
- Build package: org.openapitools.codegen.languages.PythonClientCodegen
For more information, please visit [https://www.google.com](https://www.google.com)

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import kfp_tekton_server_api
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import kfp_tekton_server_api
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function

import time
import kfp_tekton_server_api
from kfp_tekton_server_api.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = kfp_tekton_server_api.Configuration(
    host = "http://localhost"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: Bearer
configuration = kfp_tekton_server_api.Configuration(
    host = "http://localhost",
    api_key = {
        'authorization': 'YOUR_API_KEY'
    }
)
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['authorization'] = 'Bearer'


# Enter a context with an instance of the API client
with kfp_tekton_server_api.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = kfp_tekton_server_api.ExperimentServiceApi(api_client)
    id = 'id_example' # str | The ID of the experiment to be archived.

    try:
        # Archives an experiment and the experiment's runs and jobs.
        api_response = api_instance.experiment_service_archive_experiment(id)
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling ExperimentServiceApi->experiment_service_archive_experiment: %s\n" % e)
    
```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ExperimentServiceApi* | [**experiment_service_archive_experiment**](docs/ExperimentServiceApi.md#experiment_service_archive_experiment) | **POST** /apis/v1/experiments/{id}:archive | Archives an experiment and the experiment&#39;s runs and jobs.
*ExperimentServiceApi* | [**experiment_service_create_experiment**](docs/ExperimentServiceApi.md#experiment_service_create_experiment) | **POST** /apis/v1/experiments | Creates a new experiment.
*ExperimentServiceApi* | [**experiment_service_delete_experiment**](docs/ExperimentServiceApi.md#experiment_service_delete_experiment) | **DELETE** /apis/v1/experiments/{id} | Deletes an experiment without deleting the experiment&#39;s runs and jobs. To avoid unexpected behaviors, delete an experiment&#39;s runs and jobs before deleting the experiment.
*ExperimentServiceApi* | [**experiment_service_get_experiment**](docs/ExperimentServiceApi.md#experiment_service_get_experiment) | **GET** /apis/v1/experiments/{id} | Finds a specific experiment by ID.
*ExperimentServiceApi* | [**experiment_service_list_experiment**](docs/ExperimentServiceApi.md#experiment_service_list_experiment) | **GET** /apis/v1/experiments | Finds all experiments. Supports pagination, and sorting on certain fields.
*ExperimentServiceApi* | [**experiment_service_unarchive_experiment**](docs/ExperimentServiceApi.md#experiment_service_unarchive_experiment) | **POST** /apis/v1/experiments/{id}:unarchive | Restores an archived experiment. The experiment&#39;s archived runs and jobs will stay archived.
*HealthzServiceApi* | [**healthz_service_get_healthz**](docs/HealthzServiceApi.md#healthz_service_get_healthz) | **GET** /apis/v1/healthz | Get healthz data.
*JobServiceApi* | [**job_service_create_job**](docs/JobServiceApi.md#job_service_create_job) | **POST** /apis/v1/jobs | Creates a new job.
*JobServiceApi* | [**job_service_delete_job**](docs/JobServiceApi.md#job_service_delete_job) | **DELETE** /apis/v1/jobs/{id} | Deletes a job.
*JobServiceApi* | [**job_service_disable_job**](docs/JobServiceApi.md#job_service_disable_job) | **POST** /apis/v1/jobs/{id}/disable | Stops a job and all its associated runs. The job is not deleted.
*JobServiceApi* | [**job_service_enable_job**](docs/JobServiceApi.md#job_service_enable_job) | **POST** /apis/v1/jobs/{id}/enable | Restarts a job that was previously stopped. All runs associated with the job will continue.
*JobServiceApi* | [**job_service_get_job**](docs/JobServiceApi.md#job_service_get_job) | **GET** /apis/v1/jobs/{id} | Finds a specific job by ID.
*JobServiceApi* | [**job_service_list_jobs**](docs/JobServiceApi.md#job_service_list_jobs) | **GET** /apis/v1/jobs | Finds all jobs.
*PipelineServiceApi* | [**pipeline_service_create_pipeline**](docs/PipelineServiceApi.md#pipeline_service_create_pipeline) | **POST** /apis/v1/pipelines | Creates a pipeline.
*PipelineServiceApi* | [**pipeline_service_create_pipeline_version**](docs/PipelineServiceApi.md#pipeline_service_create_pipeline_version) | **POST** /apis/v1/pipeline_versions | Adds a pipeline version to the specified pipeline.
*PipelineServiceApi* | [**pipeline_service_delete_pipeline**](docs/PipelineServiceApi.md#pipeline_service_delete_pipeline) | **DELETE** /apis/v1/pipelines/{id} | Deletes a pipeline and its pipeline versions.
*PipelineServiceApi* | [**pipeline_service_delete_pipeline_version**](docs/PipelineServiceApi.md#pipeline_service_delete_pipeline_version) | **DELETE** /apis/v1/pipeline_versions/{versionId} | Deletes a pipeline version by pipeline version ID. If the deleted pipeline version is the default pipeline version, the pipeline&#39;s default version changes to the pipeline&#39;s most recent pipeline version. If there are no remaining pipeline versions, the pipeline will have no default version. Examines the run_service_api.ipynb notebook to learn more about creating a run using a pipeline version (https://github.com/kubeflow/pipelines/blob/master/tools/benchmarks/run_service_api.ipynb).
*PipelineServiceApi* | [**pipeline_service_get_pipeline**](docs/PipelineServiceApi.md#pipeline_service_get_pipeline) | **GET** /apis/v1/pipelines/{id} | Finds a specific pipeline by ID.
*PipelineServiceApi* | [**pipeline_service_get_pipeline_version**](docs/PipelineServiceApi.md#pipeline_service_get_pipeline_version) | **GET** /apis/v1/pipeline_versions/{versionId} | Gets a pipeline version by pipeline version ID.
*PipelineServiceApi* | [**pipeline_service_get_pipeline_version_template**](docs/PipelineServiceApi.md#pipeline_service_get_pipeline_version_template) | **GET** /apis/v1/pipeline_versions/{versionId}/templates | Returns a YAML template that contains the specified pipeline version&#39;s description, parameters and metadata.
*PipelineServiceApi* | [**pipeline_service_get_template**](docs/PipelineServiceApi.md#pipeline_service_get_template) | **GET** /apis/v1/pipelines/{id}/templates | Returns a single YAML template that contains the description, parameters, and metadata associated with the pipeline provided.
*PipelineServiceApi* | [**pipeline_service_list_pipeline_versions**](docs/PipelineServiceApi.md#pipeline_service_list_pipeline_versions) | **GET** /apis/v1/pipeline_versions | Lists all pipeline versions of a given pipeline.
*PipelineServiceApi* | [**pipeline_service_list_pipelines**](docs/PipelineServiceApi.md#pipeline_service_list_pipelines) | **GET** /apis/v1/pipelines | Finds all pipelines.
*PipelineServiceApi* | [**pipeline_service_update_pipeline_default_version**](docs/PipelineServiceApi.md#pipeline_service_update_pipeline_default_version) | **POST** /apis/v1/pipelines/{pipelineId}/default_version/{versionId} | Update the default pipeline version of a specific pipeline.
*PipelineUploadServiceApi* | [**pipeline_service_upload_pipeline**](docs/PipelineUploadServiceApi.md#pipeline_service_upload_pipeline) | **POST** /apis/v1/pipelines/upload | 
*PipelineUploadServiceApi* | [**pipeline_service_upload_pipeline_version**](docs/PipelineUploadServiceApi.md#pipeline_service_upload_pipeline_version) | **POST** /apis/v1/pipelines/upload_version | 
*RunServiceApi* | [**run_service_archive_run**](docs/RunServiceApi.md#run_service_archive_run) | **POST** /apis/v1/runs/{id}:archive | Archives a run.
*RunServiceApi* | [**run_service_create_run**](docs/RunServiceApi.md#run_service_create_run) | **POST** /apis/v1/runs | Creates a new run.
*RunServiceApi* | [**run_service_delete_run**](docs/RunServiceApi.md#run_service_delete_run) | **DELETE** /apis/v1/runs/{id} | Deletes a run.
*RunServiceApi* | [**run_service_get_run**](docs/RunServiceApi.md#run_service_get_run) | **GET** /apis/v1/runs/{runId} | Finds a specific run by ID.
*RunServiceApi* | [**run_service_list_runs**](docs/RunServiceApi.md#run_service_list_runs) | **GET** /apis/v1/runs | Finds all runs.
*RunServiceApi* | [**run_service_read_artifact**](docs/RunServiceApi.md#run_service_read_artifact) | **GET** /apis/v1/runs/{runId}/nodes/{nodeId}/artifacts/{artifactName}:read | Finds a run&#39;s artifact data.
*RunServiceApi* | [**run_service_report_run_metrics**](docs/RunServiceApi.md#run_service_report_run_metrics) | **POST** /apis/v1/runs/{runId}:reportMetrics | ReportRunMetrics reports metrics of a run. Each metric is reported in its own transaction, so this API accepts partial failures. Metric can be uniquely identified by (run_id, node_id, name). Duplicate reporting will be ignored by the API. First reporting wins.
*RunServiceApi* | [**run_service_retry_run**](docs/RunServiceApi.md#run_service_retry_run) | **POST** /apis/v1/runs/{runId}/retry | Re-initiates a failed or terminated run.
*RunServiceApi* | [**run_service_terminate_run**](docs/RunServiceApi.md#run_service_terminate_run) | **POST** /apis/v1/runs/{runId}/terminate | Terminates an active run.
*RunServiceApi* | [**run_service_unarchive_run**](docs/RunServiceApi.md#run_service_unarchive_run) | **POST** /apis/v1/runs/{id}:unarchive | Restores an archived run.


## Documentation For Models

 - [GooglerpcStatus](docs/GooglerpcStatus.md)
 - [InlineObject](docs/InlineObject.md)
 - [JobMode](docs/JobMode.md)
 - [PipelineSpecRuntimeConfig](docs/PipelineSpecRuntimeConfig.md)
 - [ProtobufAny](docs/ProtobufAny.md)
 - [ReportRunMetricsResponseReportRunMetricResult](docs/ReportRunMetricsResponseReportRunMetricResult.md)
 - [ReportRunMetricsResponseReportRunMetricResultStatus](docs/ReportRunMetricsResponseReportRunMetricResultStatus.md)
 - [RunMetricFormat](docs/RunMetricFormat.md)
 - [V1CronSchedule](docs/V1CronSchedule.md)
 - [V1Experiment](docs/V1Experiment.md)
 - [V1ExperimentStorageState](docs/V1ExperimentStorageState.md)
 - [V1GetHealthzResponse](docs/V1GetHealthzResponse.md)
 - [V1GetTemplateResponse](docs/V1GetTemplateResponse.md)
 - [V1Job](docs/V1Job.md)
 - [V1ListExperimentsResponse](docs/V1ListExperimentsResponse.md)
 - [V1ListJobsResponse](docs/V1ListJobsResponse.md)
 - [V1ListPipelineVersionsResponse](docs/V1ListPipelineVersionsResponse.md)
 - [V1ListPipelinesResponse](docs/V1ListPipelinesResponse.md)
 - [V1ListRunsResponse](docs/V1ListRunsResponse.md)
 - [V1Parameter](docs/V1Parameter.md)
 - [V1PeriodicSchedule](docs/V1PeriodicSchedule.md)
 - [V1Pipeline](docs/V1Pipeline.md)
 - [V1PipelineRuntime](docs/V1PipelineRuntime.md)
 - [V1PipelineSpec](docs/V1PipelineSpec.md)
 - [V1PipelineVersion](docs/V1PipelineVersion.md)
 - [V1ReadArtifactResponse](docs/V1ReadArtifactResponse.md)
 - [V1Relationship](docs/V1Relationship.md)
 - [V1ReportRunMetricsResponse](docs/V1ReportRunMetricsResponse.md)
 - [V1ResourceKey](docs/V1ResourceKey.md)
 - [V1ResourceReference](docs/V1ResourceReference.md)
 - [V1ResourceType](docs/V1ResourceType.md)
 - [V1Run](docs/V1Run.md)
 - [V1RunDetail](docs/V1RunDetail.md)
 - [V1RunMetric](docs/V1RunMetric.md)
 - [V1RunStorageState](docs/V1RunStorageState.md)
 - [V1Trigger](docs/V1Trigger.md)
 - [V1Url](docs/V1Url.md)
 - [V1Value](docs/V1Value.md)


## Documentation For Authorization


## Bearer

- **Type**: API key
- **API key parameter name**: authorization
- **Location**: HTTP header


## Author

kubeflow-pipelines@google.com


